/*
 * Created on Nov 24, 2003
 */
package kerberos.exceptions;

/**
 * Diese Exception wird geworfen, wenn mit einer Factory gearbeitet werden soll, diese
 * Factory aber schon mit destroy() zerstrt wurde, um enthaltenen sensible Daten
 * unleserlich zu machen.
 * @author Stephan Koops
 */
public class FactoryDestroyedException extends KerberosException
{
	/**
	 * @param klasse Klasse, dessen Objekt schon zerstrt wurde.
	 */
	public FactoryDestroyedException(Class factoryClass)
	{
		super("Die " + factoryClass.getName() + " wurde zerstrt");
	}
}
