/*
 * Created on 05.01.2004
 */
package kerberos.exceptions;

/**
 * Die KerberosRuntimeException wird geworfen, wenn es ein Kerberos-Problem gab, was
 * aber eigentlich gar nicht auftreten sollte. Sie erbt von der java.lang.RuntimeException
 * @author Stephan Koops
 */
public class KerberosRuntimeException extends RuntimeException
{

	/**
	 * 
	 */
	public KerberosRuntimeException()
	{
		super();
	}

	/**
	 * @param message
	 */
	public KerberosRuntimeException(String message)
	{
		super(message);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public KerberosRuntimeException(String message, Throwable cause)
	{
		super(message, cause);
	}

	/**
	 * @param cause
	 */
	public KerberosRuntimeException(Throwable cause)
	{
		super(cause);
	}

	/**
	 * Wirft eine KerberosRuntimeException. Wenn die bergebene Exception 
	 * eine Exception als Grund hat, wird diese als Grund fr die KerberosRuntimeException
	 * angegeben. Die Message der bergebenen Exception wird immer weitergegeben.<br>
	 * Diese Methode kann auch mit wie folgt aufgerufen werden, wenn es fr die Kompilierung 
	 * ntig ist, dass schon beim Kompilieren erkannt wird, dass die Methode hier abgebrochen wird:
	 * <code>throw KerberosRuntimeException throwWith(exc)</code>.
	 */
	public static KerberosRuntimeException throwWith(Exception exc) throws KerberosRuntimeException
	{
		if(exc.getCause() != null)
			throw new KerberosRuntimeException(exc.getMessage(),exc.getCause());
		else
			throw new KerberosRuntimeException(exc.getMessage());
	}
}
