/*
 * Created on 13.10.2003
 */
package kerberos.exceptions;


/**
 * Eine PasswortFalschException wird geworfen, wenn sich die Daten nicht mit dem bergebenen Passwort entschlsseln
 * lassen. Dann war entweder das eingegebene Passwort falsch oder die Nachricht wurde mit dem falschen Schlssel
 * verschlsselt, d.h. sie wurde von jemanden versandt, der das Passwort nicht kennt. Der wollte dann wohl in die
 * Verschlsselung einbrechen.
 * @author Stephan Koops
 */
public class PasswortFalschException extends KerberosException
{

	public PasswortFalschException()
	{
		super("Das angegebene Passwort ist falsch");
	}

	public PasswortFalschException(String message)
	{
		super(message);
	}
}
