/*
 * Created on Nov 17, 2003
 */
package kerberos.messages;

import kerberos.exceptions.NonceFalschException;

/**
 * @author Stephan Koops
 * 
 * Dieses Interface ist fr alle Message-Klassen M_AP_*
 */
public interface M_AP {
	/**
	 * Vergleicht den Noncewert mit dem Noncewert aus der Message.
	 * @throws NonceFalschException wenn die Noncewerte nicht bereinstimmen.
	 */	
	public void checkNonce(long mynonce) throws NonceFalschException;
	
	/**
	 * Gibt den Nonce-Wert der Nachricht zurck
	 * @return Noncewert (long)
	 */
	public long getNonce();
	
	/**
	 * Gibt die unverschlsselten Daten zurck.
	 * @return unverschlsselte Daten.
	 */
	public byte[] getDaten();
}
