/*
 * Created on Nov 3, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kerberos.messages;

import kerberos.packets.*;

/**
 * Dient zum Auslesen der Anfrage des Clients zum Autenticationservices.
 * 
 * @author stier_j
 */
public class M_KDC_AS_REQ extends Message implements M_KDC_REQ 
{
	String Client = null;
	long Nonce = 0;
	
	/**
	 * @param uncryptDaten Diese Daten sind unverschlsselt
	 * @throws PacketException
	 */
	M_KDC_AS_REQ(byte[] uncryptDaten) throws PacketException
	{
		PacketReader pr = new PacketReader(uncryptDaten);
		Client = pr.readStringNonCrypt();
		Nonce = pr.readNonceNonCrypt();
	}
	
	/**
	 * Vergleicht den Noncewert mit dem Noncewert aus der Message.
	 * </br>
	 * <b>Hier nicht benutzt.</b>
	 */	
	public void checkNonce(long nonce){}
	
	/**
	 * Gibt den ausgelesenen Noncewert zurck.
	 * @return Nonce.
	 */
	public long getNonce(){
		return Nonce;
	}
	
	/**
	 * Gibt den ausgelesenen Client Namen zurck.
	 * @return Client Name.
	 */
	public String getUsername()
	{
		if(Client == null)
			throw new NullPointerException();
		return Client; 
	}

	/**
	 * @see kerberos.messages.Message#getType()
	 */
	public int getType()
	{
		return M_KDC_AS_REQ;
	}
}
