/*
 * Created on 10.01.2004
 */
package kerberos.server.keyaccess;

import kerberos.server.KDCProperties;

/**
 * Abstrakte Klasse von dem alle KeyAccessor erben.<br>
 * Ausserdem stellt sie eine Klassenmethode <code>getKeyAccessor()</code>
 * bereit, um die Instance, des in der KDC.properties eingestellten
 * KeyAccessor-Klasse zu bekommen.
 * @author Sven Elvers
 */
public abstract class AbstractKeyAccessor implements IKeyAccessor {

	//Schlssel fr die KDC.properties
	private static final String BANK_KEY = "<KeyAccessor-KeyDatabase>";

	/**
	 * schaut nach welche Schlsselbank genommen werden soll,
	 * und gibt dann den passenden KeyAccessor zurck.
	 * @return
	 * den in der KDC.properties eingestellten KeyAccessor
	 */
	public static IKeyAccessor getKeyAccessor() {
		String key = KDCProperties.getInstace().getString(BANK_KEY);
		if (key.equalsIgnoreCase("File"))
			return KeyFileAccessor.getInstace();
			
		return null;
	}
	
}
