/*
 * Created on 01.11.2003
 *
 */
package kerberos.server.keyaccess;

/**
 * @author Sven Elvers, Christian Morgenstern
 *
 */
public interface IKeyAccessor {

	/**
	 * hole den Schlssel zu einem Prinzipal
	 * @param user Prinzipal
	 * @return
	 */
	byte[] getKey(String user);
	
	/**
	 * ndert den Schlssel eines Prinzipal
	 * @param user Prinzipal
	 * @param key neuer Schlssel
	 * @return true, wenn es erfolgreich war
	 * @throws Exception
	 */
	boolean changeKey(String user, byte[] key) throws Exception;
	
	/**
	 * neuen Prinzipal anlegen
	 * @param user Prinzipal
	 * @param key Schlssel
	 * @return true, wenn es erfolgreich war
	 * @throws Exception
	 */
	boolean addToken(String user, byte[] key) throws Exception;
	
	/**
	 * Prinzipal lschen
	 * @param user Prinzipal
	 * @return true, wenn es erfolgreich war
	 * @throws Exception
	 */
	boolean removeToken(String user) throws Exception;
}
