/*
 * Created on Nov 17, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kerberos.tests;

// connect localhost 1234 testserver

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

import kerberos.exceptions.KerberosException;
import kerberos.exceptions.PasswortFalschException;
import kerberos.net.KerberosClientSocketFactory;
import kerberos.net.KerberosSocket;
import kerberos.net.KerberosClientSocketFactoryImpl;
import kerberos.net.Passwort;

/**
 * @author elvers_s
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestClientConsole
{
	private KerberosClientSocketFactory tgs = null;
	private BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

	public TestClientConsole(String username, String passwort, String kdc_host)
		throws PasswortFalschException, IOException, KerberosException
	{
		Passwort pass = new Passwort(passwort.getBytes());
		tgs = new KerberosClientSocketFactoryImpl(username, pass, kdc_host);
	}

	public void run() throws IOException
	{
		String command = "";
		String host, name;
		int port;
		KerberosSocket socket = null;
		do
		{
			System.out.print("ConnectNow: ");
			StringTokenizer st = new StringTokenizer(in.readLine());
			command = st.nextToken();

			if (command.equalsIgnoreCase("connect"))
			{
				try
				{
					host = st.nextToken();
					if (host.equalsIgnoreCase("l2s"))
					{
						host = "localhost";
						port = 2000;
						name = "testserver";
					}
					else
					{
						port = Integer.parseInt(st.nextToken());
						name = st.nextToken();
					}
					socket = tgs.connect(host, port, name);
					handleConnection(socket);
				}
				catch (NoSuchElementException nsee)
				{
					System.out.println("connect host port name");
				}
				catch (Exception e)
				{
					try
					{
						Thread.sleep(100);
					}
					catch (InterruptedException e1)
					{
					}
					//System.out.println(e.getMessage());
					e.printStackTrace();
					try
					{
						Thread.sleep(100);
					}
					catch (InterruptedException e1)
					{
					}
					System.out.println("connect host port name");
				}
			}
			else if (command.equalsIgnoreCase("info"))
			{
				System.out.println("AVAILABLE: connect | close");
			}
		}
		while (!command.equalsIgnoreCase("close") && !command.equalsIgnoreCase("exit"));
	}

	/**
	 * @param socket
	 */
	private void handleConnection(KerberosSocket socket) throws IOException
	{
		String command = "";
		do
		{
			System.out.print("Eingeloggt: ");
			StringTokenizer st = new StringTokenizer(in.readLine());
			command = st.nextToken();

			if (command.equalsIgnoreCase("send"))
			{
				try
				{
					socket.print(st.nextToken("\n"));
					String empf = socket.readString();
					System.out.print("Empfangen : ");
					System.out.println(empf);
				}
				catch (KerberosException e)
				{
					try
					{
						Thread.sleep(100);
					}
					catch (InterruptedException e1)
					{
					}
					System.out.println(e.getMessage());
					try
					{
						Thread.sleep(100);
					}
					catch (InterruptedException e1)
					{
					}
				}
			}
			else if (command.equalsIgnoreCase("info"))
			{
				System.out.println("AVAILABLE: send | disconnect");
			}
		}
		while (!command.equalsIgnoreCase("disconnect") && !command.equalsIgnoreCase("close") && !command.equalsIgnoreCase("exit"));
		try
		{
			System.out.print("Verbindung schlieen");
			socket.print("disconnect");
			System.out.println(" - geschlossen");
		}
		catch (KerberosException e)
		{
			System.out.println(" - Fehler:");
			System.err.println("TestServerConsole:");
			e.printStackTrace();
		}
		catch (IOException e)
		{
			System.out.println(" - Fehler:");
			System.err.println("TestServerConsole:");
			e.printStackTrace();
		}
	}

	public static void main(String[] args)
	{
		if (args.length == 3)
		{
			try
			{
				new TestClientConsole(args[0], args[1], args[2]).run();
			}
			catch (PasswortFalschException e)
			{
				System.out.println("Das Passwort ist falsch: " + args[1]);
			}
			catch (IOException e)
			{
				System.out.println("Verbindungsfehler ist aufgetreten: " + e.getMessage());
			}
			catch (KerberosException e)
			{
				System.out.println("Kerberos-Fehler " + e.getMessage());
			}
		}
		System.out.println("TestClientConsole username passwort kdc_host");
	}
}
