/*
 * Created on Nov 17, 2003
 */
package kerberos.tests;

import java.io.IOException;
import java.io.PrintStream;

import kerberos.exceptions.KerberosException;
import kerberos.exceptions.KerberosRuntimeException;
import kerberos.exceptions.PasswortDestroyedException;
import kerberos.exceptions.PasswortFalschException;
import kerberos.net.KerberosServerSocket;
import kerberos.net.KerberosServerSocketImpl;
import kerberos.net.KerberosSocket;
import kerberos.net.Passwort;
import kerberos.packets.PacketReader;

/**
 * @author Sven Elvers
 */
public class TestServerConsole
{
	private KerberosServerSocket serversocket = null;
	public static PrintStream ERR_OUT = System.out;

	public TestServerConsole(int port, String password)
		throws PasswortFalschException, PasswortDestroyedException, IOException
	{
		Passwort pass = new Passwort(password.getBytes());
		serversocket = new KerberosServerSocketImpl(port, pass);
		PacketReader.debugOff();
	}

	public void run()
	{
		System.out.println("TestServerConsole wartet auf Clients");
		while (true)
		{
			KerberosSocket socket = null;
			try
			{
				System.out.println("TestServerConsole.run: Warten auf eine Verbindung");
				socket = serversocket.accept();
				System.out.println(socket.getUsername()+" hat sich eingeloggt von "+socket.getInetAddress());
				boolean ende = false;
				while(! ende)
				{
					String data = socket.readString();
					if(data.equalsIgnoreCase("disconnect"))
					{
						System.out.println("Verbindung wird geschlossen");
						ende = true;
					}
					else
					{
						System.out.println("Empfangene Daten: " + data);
						socket.print("O_o was willst du? " + data);
					}
				}
			}
			catch (KerberosRuntimeException re)
			{
				System.out.println("TestServerConsole:");
				re.printStackTrace(ERR_OUT);
			}
			catch (IOException ioe)
			{
				System.out.println("TestServerConsole:");
				ioe.printStackTrace(ERR_OUT);
			}
			catch (KerberosException ke)
			{
				System.out.println("TestServerConsole:");
				ke.printStackTrace(ERR_OUT);
			}
			finally
			{
				if (socket != null) try {
					socket.close();  } catch (IOException ioe) { }
			}
		}
		/*// Wegen endlos-Schleife nicht mglich
		try
		{
			serversocket.close();
		}
		catch (IOException e1){} //*/
	}

	public static void main(String[] args)
	{
		if (args.length == 2)
		{
			try
			{
				int port = Integer.parseInt(args[0]);
				TestServerConsole console = new TestServerConsole(port, args[1]);
				console.run();
			}
			catch (NumberFormatException e)
			{
				System.out.println("Hier wird ein Port erwartet: " + args[0]);
			}
			catch (PasswortFalschException e)
			{
				System.out.println("Das Passwort ist falsch: " + args[1]);
			}
			catch (IOException e)
			{
				System.out.println("Verbindungsfehler ist aufgetreten: " + e.getMessage());
			} 
			catch (PasswortDestroyedException e)
			{
				System.out.println(e.getMessage());
			}
		}
		System.out.println("TestServerConsole port passwort");
	}
}
