/*
 * Created on 20.10.2003
 */
package kerberos.tests.sockets;

import junit.framework.Test;
import junit.framework.TestSuite;
import kerberos.net.KerberosClientSocketFactory;
import kerberos.net.KerberosClientSocketFactoryImpl;
import kerberos.net.KerberosSocket;
import kerberos.net.Passwort;
import kerberos.tests.TestCase;

/**
 * @author Stephan Koops
 */
public class KerberosSocketClient extends TestCase
{
	/** Speichert, wie oft in kurzer String aneinandergefgt wird. */
	public static final int LONG_STRING_TIMES = 20; //67000;
	
	public boolean output = false;

	/**
	 * Um die Klasse als Anwendung zu starten
	 */
	public KerberosSocketClient()
	{
		super();
		this.output = true;
	}

	public static Test suite()
	{
		return new TestSuite(KerberosSocketClient.class);
	} 
	
	public static final String KDC_HOST = "127.0.0.1"; 
	public static final String ZIELDIENST_HOST = "127.0.0.1";
	
	public void test1() throws Exception
	{
		KerberosClientSocketFactory socketFactory;
		try
		{
			System.out.println("kerberos.tests.KerberosSocketsClient schickt gleich ne Anfrage los !");
			socketFactory = new KerberosClientSocketFactoryImpl("testuser", new Passwort("test"),KDC_HOST);
		}
		catch (Exception e)
		{
			System.err.println("to KDC:");
			e.printStackTrace();
			throw e;
		}
		try
		{
			KerberosSocket socket = socketFactory.connect(ZIELDIENST_HOST,2000,"testserver");
			toFromSocket(socket,"Es folgt ein leerer String");
			toFromSocket(socket,"     ");
			toFromSocket(socket,"Es");
			toFromSocket(socket,"E");
			toFromSocket(socket,"");
			String longString;
			StringBuffer stb = new StringBuffer();
			for( int i = 1 ; i < LONG_STRING_TIMES ; i++ )
				stb.append("LongString");
			longString = stb.toString();
			toFromSocket(socket,"Es folgt ein langer String");
			toFromSocket(socket,longString);
			toSocket(socket,"disconnect");
			//Thread.sleep(5000);
			socket.close();
			if(output)
				System.out.println("write  beendet");
		}
		catch (Exception e)
		{
			System.err.println("to Zieldienst:");
			e.printStackTrace();
			throw e;
		}
	}

	public void fromSocketByteArray(KerberosSocket socket) throws Exception
	{
		byte[] byteArray = socket.read();				
		if(output)
			System.out.print("  READ, byte[]: ");
		printBytes(byteArray);
		if(output)
			System.out.println();				
	}

	public void toSocket(KerberosSocket socket, String string) throws Exception
	{
		toSocket(socket, string.getBytes());
	}
	
	public void toSocket(KerberosSocket socket, byte[] byteArray) throws Exception
	{
		if(output)
			System.out.print("write,  byte[]: ");
		printBytes(byteArray);
		if(output)
			System.out.println();
		socket.print(byteArray);
	}
	
	public void toFromSocket(KerberosSocket socket, String string) throws Exception
	{
		toSocket(socket, string.getBytes());
		fromSocketByteArray(socket);
	}
	
	public void printBytes(byte[] bytes)
	{
		if (output)
			System.out.println(Passwort.toZahl(bytes));
	}
}