/*
 * Created on 15.12.2003
 */
package kerberos.tests.sockets;

import java.io.IOException;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import kerberos.exceptions.KerberosException;
import kerberos.net.KerberosClientSocketFactory;
import kerberos.net.KerberosSocket;
import kerberos.net.KerberosClientSocketFactoryImpl;
import kerberos.net.Passwort;
import kerberos.packets.PacketReader;

/**
 * Diese Tests basieren auf der TestServerConsole. Diese muss, wie der KDC, laufen. 
 * @author Stephan
 */
public class KerberosSocketTests2 extends TestCase
{
	public static final int testServerConsolenPort = 2000; //1234;
	private KerberosClientSocketFactory socketFactory;

	public KerberosSocketTests2(String arg0)
	{
		super(arg0);
	}

	public static void main(String[] args)
	{
	}

	public static Test suite()
	{
		return new TestSuite(KerberosSocketTests2.class);
	}

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception
	{
		super.setUp();
		System.out.println("Der KDC muss laufen , ebenso die TestServerConsole auf Port "+testServerConsolenPort+"!!");
		this.socketFactory = new KerberosClientSocketFactoryImpl("testuser", new Passwort("test"), "localhost");
		PacketReader.debugOff();
	}

	public void test1() throws IOException, KerberosException
	{
		KerberosSocket socket = this.socketFactory.connect("localhost", testServerConsolenPort, "testserver");
		socket.print("1234");
		System.out.println("Wenn das Programm hier hngt, dann gabs in der TestServerConsole eine Exception");
		socket.read();
		socket.print("disconnect");
	}

	public void test2() throws IOException, KerberosException
	{
		KerberosSocket socket = this.socketFactory.connect("localhost", testServerConsolenPort, "testserver");
		socket.print("hello world!");
		System.out.println("Wenn das Programm hier hngt, dann gabs in der TestServerConsole eine Exception");
		socket.read();
		socket.print("disconnect");
	}

	public void test3() throws IOException, KerberosException
	{
		KerberosSocket socket = this.socketFactory.connect("localhost", testServerConsolenPort, "testserver");
		socket.print((String)null);
		System.out.println("Wenn das Programm hier hngt, dann gabs in der TestServerConsole eine Exception");
		socket.read();
		socket.print("disconnect");
	}
}
