/*
 * Created on 20.10.2003
 */
package kerberos.tests.sockets;

import java.util.ArrayList;
import java.util.List;

import junit.framework.Test;
import junit.framework.TestSuite;
import kerberos.net.KerberosClientSocketFactory;
import kerberos.net.KerberosServerSocket;
import kerberos.net.KerberosSocket;
import kerberos.net.Passwort;
import kerberos.net.test.KerberosTestClientSocketFactory;
import kerberos.net.test.KerberosTestServerSocket;
import kerberos.tests.TestCase;

/**
 * @author Stephan Koops
 */
public class KerberosTestSocketTests extends TestCase
{
	public List written = new ArrayList();
	public boolean output = ! false;

	public KerberosTestSocketTests(String name)
	{
		super(name);
	}

	/**
	 * Um die Klasse als Anwendung zu starten
	 */
	protected KerberosTestSocketTests()
	{
		super();
		this.output = true;
	}

	public static Test suite()
	{
		return new TestSuite(KerberosTestSocketTests.class);
	}

	public void setUp()
	{
	}

	public static void main(String[] args) throws Exception
	{
		new KerberosTestSocketTests().test1();
	}
	
	public void test1() throws Exception
	{
		KerberosServerSocket serverSocket = new KerberosTestServerSocket(2001,null);
		Thread writer = new Thread(){
			public void run()
			{
				try
				{
					Thread.sleep(500);
					KerberosClientSocketFactory socketFactory = new KerberosTestClientSocketFactory(null,null,null);
					KerberosSocket socket = socketFactory.connect("localhost",2001,null);
					toSocket(socket,"Hallo Duda djflwdjhekf".getBytes());
					toSocket(socket,"Hallo Duda djflwdjhekf".getBytes());
					toSocket(socket,"Hallo Duda djflwdjhekf");
					toSocket(socket,"wjnqwuwibgh twfwggvvarc".getBytes());
					toSocket(socket,"Hallo Duda djflwdjhekf".getBytes());
					Thread.sleep(500);
					socket.close();
					if(output)
						System.out.println("write  beendet");
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		};
		writer.start();
		
		System.out.println("KerberosTestSocketTests.test1: Verbindung annehmen:"); 
		KerberosSocket socket = serverSocket.accept();
		System.out.println("KerberosTestSocketTests.test1: Lesen1:");
		fromSocketByteArray(socket);
		System.out.println("KerberosTestSocketTests.test1: Lesen2:");
		fromSocketByteArray(socket);
		System.out.println("KerberosTestSocketTests.test1: Lesen3:");
		fromSocketByteArray(socket);
		System.out.println("KerberosTestSocketTests.test1: Lesen4:");
		fromSocketByteArray(socket);
		System.out.println("KerberosTestSocketTests.test1: Lesen5:");
		fromSocketByteArray(socket);
		socket.close();
		serverSocket.close();
		if(output)
			System.out.println(" READ beendet");				
	}

	public void fromSocketByteArray(KerberosSocket socket) throws Exception
	{
		byte[] byteArray = socket.read();				
		if(output)
			System.out.print("  READ, byte[]: ");
		printBytes(byteArray);
		Object o = written.get(0);
		if (o instanceof byte[])
			assertEquals((byte[])o,byteArray);
		if (o instanceof String)
			assertEquals(((String)o).getBytes(),byteArray);
		written.remove(0);
		if(output)
			System.out.println();
	}

	public void toSocket(KerberosSocket socket, byte[] byteArray) throws Exception
	{
		if(output)
			System.out.print("write,  byte[]: ");
		printBytes(byteArray);
		if(output)
			System.out.println();
		written.add(byteArray);
		socket.print(byteArray);
		Thread.sleep(100);
	}
	
	public void toSocket(KerberosSocket socket, String string) throws Exception
	{
		if(output)
			System.out.print("write,  String: ");
		printBytes(string);
		if(output)
			System.out.println();
		written.add(string);
		socket.print(string);
		Thread.sleep(100);
	}
	
	public void printBytes(byte[] bytes)
	{
		if(output)
			System.out.print(Passwort.toZahl(bytes));
	}

	public void printBytes(String string)
	{
		if(output)
		{
			System.out.print(string);
		}
	}
}