package util;

public final class Semaphore
{
	/** Zhlt die Anzahl der Leute, die noch reindrfen */
	private int count;

	/** Erzeugt eine Semaphore, mit dem Startwert 1. */
	public Semaphore()
	{
		count = 1;
	}

	public Semaphore(int value)
	{
		count = value;
	}

	public synchronized void betreten()
	{
		while (count <= 0)
		{
			try
			{
				wait();
			}
			catch (InterruptedException e)
			{
				Thread.currentThread().interrupt();
				break;
			}
		}
		count--;
	}

	public synchronized void verlassen()
	{
		++count;

		notify();
	}

	public int getCounter()
	{
		return count;
	}
}
