/*
 * Created on Jan 19, 2004
 */
package util.logger;

/**
 * Dieses Interface beschreibt eine Klasse, die Ereignisse mitloggen
 * kann. Diese Klasse kann z.B. auch ein Wrapper um einen anderen Logger sein.
 * @author Stephan Koops
 */
public interface Logger 
{
	/**
	 * Loggt die Exception
	 * @param exc
	 * @param prio Log-Prioritt dieser Exception.
	 * Je hher die Zahl, desto wichtiger das Ereignis.
	 * @see #setMinLog(int)
	 */
	public void log(Exception exc, int prio);
	
	/**
	 * Loggt den bergebenen String.
	 * @param info
	 * @param prio Log-Prioritt dieser Exception.
	 * Je hher die Zahl, desto wichtiger das Ereignis.
	 * @see #setMinLog(int)
	 */
	public void log(String info, int prio);
	
	/**
	 * Setzt die Priorittennumer, ab der Sachen mitgeloggt werden sollen.
	 * In Kerberos werden "normale" Ereignisse mit Prioritt 5 mitgeloggt,
	 * wichtiges Sachen werden mit Prioritt 10 mitgeloggt 
	 * @param minimalPrio
	 */
	public void setMinLog(int minimalPrio);
}
