/*
 * Created on Jan 19, 2004
 */
package util.logger;

/**
 * Dieser Logger loggt die Daten auf der Standard-Ausgabe
 * @author Stephan Koops
 */
public class SystemOutLogger implements Logger 
{
	private int minimalPrio = 10;

	/**
	 * @see Logger#log(java.lang.Exception, int)
	 */
	public void log(Exception exc, int prio)
	{
		exc.printStackTrace(System.out);
	}

	/**
	 * @see Logger#log(java.lang.String, int)
	 */
	public void log(String info, int prio) 
	{
		System.out.println(info);
	}

	/**
	 * @see Logger#setMinLog(int)
	 */
	public void setMinLog(int minimalPrio) 
	{
		this.minimalPrio = minimalPrio;
	}
}